﻿Public Class Form1
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load
        PortSearch()
        If (ComboBox1.Items.Count > 0) Then
            Button1.Enabled = True
            Button2.Enabled = False
            Button3.Enabled = True
            ComboBox1.Enabled = True
        Else
            Button1.Enabled = False
            Button2.Enabled = False
            Button3.Enabled = True
            ComboBox1.Enabled = False
        End If
    End Sub

    ' ポートを調べて、ＤＩＰＰＬＣが見つかったら、コンボボックスの一覧に追加する
    Private Sub PortSearch()
        Dim i As Integer
        Dim buf As String

        If (SerialPort1.IsOpen() = False) Then ' ポートが開いているかどうかのチェック
            ComboBox1.Items.Clear()            ' 通信ポートの一覧のコンボボックスの一覧クリア

            SerialPort1.BaudRate = 9600                 ' 通信速度を設定
            SerialPort1.StopBits = 1                    ' ストップビットの設定
            SerialPort1.Parity = IO.Ports.Parity.None   ' パリティビットの設定（なし）
            SerialPort1.ReceivedBytesThreshold = 256    ' イベントを発生させる受信データサイズを256にする
            SerialPort1.RtsEnable = False               ' ＲＴＳ信号を使用しない
            SerialPort1.Handshake = IO.Ports.Handshake.XOnXOff  ' ＸＯＮ－ＯＦＦのハンドシェイク
            SerialPort1.NewLine = vbCrLf                ' 終端文字をＣＲ・ＬＦにする
            SerialPort1.ReadTimeout = 500               ' 受信タイムアウトを500msに設定する

            ' COM1～COM15までを通信してみて返事が返ってくれば
            For i = 1 To 15
                SerialPort1.PortName = "COM" & i   ' ポート名を設定
                Try
                    SerialPort1.Open()  ' ポートを開く
                    SerialPort1.Write("R" & vbCrLf) ' 実行コマンドを送信してみる。
                    System.Threading.Thread.Sleep(100)  ' 応答待ち100ms
                    buf = SerialPort1.ReadLine()        ' 終端文字までデータが飛んでくれば
                    If ((buf = "R") Or (buf = ">")) Then    ' 返信が返ってくれば（”Ｒ＞”）
                        ComboBox1.Items.Add("COM" & i)      '
                    End If
                    SerialPort1.ReadExisting()
                    SerialPort1.Close() ' ポートを閉じる
                Catch ex As System.IO.IOException

                Catch ex As System.UnauthorizedAccessException
                    MessageBox.Show("「COM" & i & "」ポートが他のソフトウェアで使用中の可能性があります。")
                Catch ex As System.Exception
                    MessageBox.Show(ex.ToString())
                End Try
            Next
            If ComboBox1.Items.Count > 0 Then   ' 使用できるポートが１つでもあれば
                ComboBox1.SelectedIndex = 0     ' 最初のポート番号を選択する
            End If
            '            SerialPort1.ReceivedBytesThreshold = 1  ' 受信イベントを1バイトで発生に設定
        Else
            MessageBox.Show("すでにポートがオープンされています。")
        End If
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        If (ComboBox1.Items.Count <= 0) Then
            MessageBox.Show("使用できるポートがありません。ドライバが入っていないか、ほかのソフトで使用中です。")
            Return
        End If
        If (SerialPort1.IsOpen() = False) Then ' ポートが開いているかどうかのチェック
            SerialPort1.PortName = ComboBox1.Text
            SerialPort1.Open()  ' ポートを開く
            Button1.Enabled = False
            Button2.Enabled = True
            Button3.Enabled = False
            ComboBox1.Enabled = False

            Timer1.Interval = 200
            Timer1.Start()
        Else
            MessageBox.Show("すでにポートがオープンされています。")
        End If
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen()) Then
            Button1.Enabled = True
            Button2.Enabled = False
            Button3.Enabled = True
            ComboBox1.Enabled = True
            Timer1.Stop()
            SerialPort1.Close()         ' シリアルポートを閉じる
        End If
    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        Dim RecvBuf As String
        Dim buf As String()
        Dim bbuf As String

        If (SerialPort1.IsOpen() = False) Then
            Timer1.Stop()
            Return
        End If

        SerialPort1.Write("X?" & vbCrLf)
        RecvBuf = SerialPort1.ReadLine()
        RecvBuf = SerialPort1.ReadLine()
        If (RecvBuf(0) = " ") Then
            buf = RecvBuf.Substring(3).Split(" ") ' スペースでデータを分割
            bbuf = buf(0)
            Dim lbl As Label
            For i = 0 To 7
                lbl = TryCast(Me.Controls("lbl_x0" & i), Label)
                If (bbuf(7 - i) = "1") Then
                    lbl.ImageIndex = 2
                Else
                    lbl.ImageIndex = 3
                End If
            Next

            SerialPort1.ReadExisting()
        End If

        SerialPort1.Write("Y?" & vbCrLf)
        RecvBuf = SerialPort1.ReadLine()
        RecvBuf = SerialPort1.ReadLine()

        If (RecvBuf(0) = " ") Then
            buf = RecvBuf.Substring(3).Split(" ")
            bbuf = buf(0)
            Dim chk As CheckBox
            For i = 0 To 5
                chk = TryCast(Me.Controls("chk_y0" & i), CheckBox)
                If (bbuf(7 - i) = "1") Then
                    chk.ImageIndex = 0
                Else
                    chk.ImageIndex = 1
                End If
            Next
            SerialPort1.ReadExisting()
        End If
    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click
        PortSearch()
        If (ComboBox1.Items.Count > 0) Then
            Button1.Enabled = True
            Button2.Enabled = False
            Button3.Enabled = True
            ComboBox1.Enabled = True
        Else
            Button1.Enabled = False
            Button2.Enabled = False
            Button3.Enabled = True
            ComboBox1.Enabled = False
        End If
    End Sub
End Class
